#include "circuit.h"

#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include "assert.h"
#include <chrono>


bool Circuit::local_search(std::unordered_set<Fault*> &faults) {

    // 随机生成初始电路
    ls_init_circuit(faults);

    printf("generate random circuit done!\n");
    exit(0);
    
    //printf("local search!\n");

    while(true) {
        Gate* gate = ls_pick();
        if(gate == nullptr) {
            break;
        }
    }

    static int original_faults = -1;
    if(original_faults == - 1) {
        original_faults = faults.size();
    }
    static int pattern = 0;

    std::unordered_set<Fault*> tmp = faults;

    for(Fault* f : tmp) {
        if(f->gate->fault_detected[f->type]) {
            faults.erase(f);
        }
    }

    if(tmp.size() == faults.size()) pattern--;

    printf("coverage: %.3f%%\tpattern: %d\tbefore: %d\tnow: %d\n", (double)(original_faults - faults.size()) / (original_faults) * 100, ++pattern, tmp.size(), faults.size());

    if(tmp.size() == faults.size()) return false;

    return true;
}

Gate* Circuit::ls_pick() {
    return nullptr;
}

void Circuit::ls_flip(Gate* gate) {

    gate->value ^= 1;

    for(Gate* g : gate->fanouts) {
        g->value_satisfied = ( g->cal_value() == g->value );
    }



}

void Circuit::ls_update_weight() {


}

void Circuit::ls_update(Gate* stem) {


}

void Circuit::ls_init_circuit(std::unordered_set<Fault*> &faults) {

    // init value, weight and cost
    for(Gate* g : gates) {
        g->value = rand() % 2;
        g->value_unsatisfied_cost = 1;
        g->fault_propagated_weight[0] = g->fault_propagated_weight[1] = 0;
        g->fault_propagated_unsatisfied_cost[0] = g->fault_propagated_unsatisfied_cost[1] = 1;
        g->fault_detected_weight[0] = g->fault_detected_weight[1] = 0;
        g->fault_detected_unsatisfied_cost[0] = g->fault_detected_unsatisfied_cost[1] = 1;
    }

    for(Fault* f : faults) {
        f->gate->fault_propagated_weight[f->type] = 1;
        f->gate->fault_detected_weight[f->type] = 1;
    }

    for(Gate* g : rtopo_gates) {
        g->value_satisfied = ( g->cal_value() == g->value );
        g->fault_propagated_len[0] = g->cal_propagate_len(0);
        g->fault_propagated_len[1] = g->cal_propagate_len(1);
        g->fault_propagated_satisfied[0] = g->fault_propagated_satisfied[1] = 0;
        g->fault_detected_satisfied[0] = g->fault_detected_satisfied[1] = 0;
    }

    // cal score
    for(Gate* g : gates) {
        g->score = g->cal_score();
        printf("%d ", g->score);
    }

}